//------------------------------------------------------------------
#property copyright "copyleft www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  Lime
#property indicator_color2  Red
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern int    CCIperiod        = 50;
extern int    applied_price    = 5;

extern bool   ShowArrows       = false;
extern string arrowsIdentifier = "ST Arrows1";
extern double arrowsUpperGap   = 1.0;
extern double arrowsLowerGap   = 1.0;
extern color  arrowsUpColor    = LimeGreen;
extern color  arrowsDnColor    = Red;
extern int    arrowsUpCode     = 241;
extern int    arrowsDnCode     = 242; 

//
//
//
//
//

double   UpH[];
double   DnH[]; 
double   Direction[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
      SetIndexBuffer(0,UpH);   SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,DnH);   SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,Direction);

   IndicatorShortName("SuperTrend Histo");    
}
int deinit()
{
   if (ShowArrows) deleteArrows();   
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit = MathMax(Bars-counted_bars,Bars-1);
   
   //
   //
   //
   //
   //
   
      for(int i=limit; i >= 0; i--)
      {
         double cciTrend  = iCCI(NULL, 0, CCIperiod, applied_price, i);
         
         //
         //
         //
         //
         //
         
         UpH[i] = EMPTY_VALUE;
         DnH[i] = EMPTY_VALUE;
         Direction[i] = Direction[i+1];
            if (cciTrend > 0) Direction[i] =  1; 
            if (cciTrend < 0) Direction[i] = -1; 
            if (Direction[i] == -1) DnH[i] = 1;
            if (Direction[i] ==  1) UpH[i] = 1;
            manageArrow(i);       
      }
return(0);
}  

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (ShowArrows)
   {
      deleteArrow(Time[i]);
      if (Direction[i] != Direction[i+1])
      {
         if (Direction[i] == 1)  drawArrow(i,arrowsUpColor,arrowsUpCode,false);
         if (Direction[i] ==-1)  drawArrow(i,arrowsDnColor,arrowsDnCode, true);
      }
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}




    